#include <cpse/math/matrix.tpp>

namespace cpse {
namespace math {

typedef basic_matrix<2, 2> m2;

void matrix2_assign_handler::go(m2 &d, matrix_binop<binop_mul, m2, m2> s)
{
	d(0,0) = s.a(0,0)*s.b(0,0) + s.a(0,1)*s.b(1,0) + s.a(0,2)*s.b(2,0);
	d(0,1) = s.a(0,0)*s.b(0,1) + s.a(0,1)*s.b(1,1) + s.a(0,2)*s.b(2,1);
	d(1,0) = s.a(1,0)*s.b(0,0) + s.a(1,1)*s.b(1,0) + s.a(1,2)*s.b(2,0);
	d(1,1) = s.a(1,0)*s.b(0,1) + s.a(1,1)*s.b(1,1) + s.a(1,2)*s.b(2,1);
}

void matrix2_assign_handler::go(m2 &dest, matrix_unop<unop_inverse, m2> src)
{
	float det_src = det_bm(src.a);
//	if (close(det_src, 0.f))
//		throw std::logic_error("inverse of singular matrix requested");

	float d = 1.f / det_src;

	// dest = adjoint(src.a) / det(src.a)
	dest(0,0) = d * +src.a(1,1);
	dest(1,0) = d * -src.a(1,0);

	dest(0,1) = d * -src.a(0,1);
	dest(1,1) = d * +src.a(0,0);
}

} // namespace math
} // namespace cpse
